<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.bussinessratestrategy_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/bussiness/bussinessratestrategy";
  import {mapGetters} from "vuex";

  export default {
    props:{
      bussinessId: null,
    },
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "采购商",
              prop: "bussinessId",
              dicUrl: "/api/cyzh-guosen/bussiness/list?size=500",
              labelPosition: "top",
              filterable: true,
              type: "select",
              dicFormatter:(res)=>{
                return res.data.records;
              },
              props:{
                label: "name",
                value: "id"
              },
              rules: [{
                required: true,
                message: "请选择采购商",
                trigger: "blur"
              }]
            },
            {
              label: "开通产品",
              prop: "productCode",
              type: "select",
              labelPosition: "top",
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=yee_product_rate",
              props:{
                label: "dictValue",
                value: "dictKey"
              },
              rules: [{
                required: true,
                message: "请选择开通产品",
                trigger: "blur"
              }]
            },
            {
              label: "平台服务费率(千分比)：不包含支付手续费率",
              prop: "percentRate",
              labelPosition: "top",
              rules: [{
                required: true,
                message: "请输入单笔费率",
                trigger: "blur"
              }]
            }
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.bussinessratestrategy_add, false),
          viewBtn: this.vaildData(this.permission.bussinessratestrategy_view, false),
          delBtn: this.vaildData(this.permission.bussinessratestrategy_delete, false),
          editBtn: this.vaildData(this.permission.bussinessratestrategy_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if(this.bussinessId != null){
          this.form.bussinessId =  this.bussinessId;
        }
        let bussinessIdColumn = this.findObject(this.option.column, "bussinessId");
        if (["edit", "view"].includes(type)) {
          if(type == 'edit'){
            bussinessIdColumn.disabled = true;
          }
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }else{
          if(this.bussinessId != null){
            bussinessIdColumn.disabled = true;
          }else{
            bussinessIdColumn.disabled = false;
          }
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        if(this.bussinessId != null){
          params.bussinessId = this.bussinessId;
        }
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
